#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<fcntl.h>
#include	<sys/ioctl.h>
#include	<sys/errno.h>

extern	int	errno;

#define CCD_IOC_MAGIC	'v'
#define CCD_IOCSABORT	_IO(CCD_IOC_MAGIC, 1)
#define CCD_IOCSCANCEL	_IO(CCD_IOC_MAGIC, 2)
#define CCD_IOCSHANGUP	_IO(CCD_IOC_MAGIC, 3)
#define CCD_IOCSRESUME	_IO(CCD_IOC_MAGIC, 4)
#define CCD_IOCSTEST    _IO(CCD_IOC_MAGIC, 5)

#define	USAGE			"Usage: ccd_ioctl { a(bort) | c(ancel) | h(angup) | r(esume) | t(test)}\n"

int
main(int argc, char **argv)
{
	int		fd;

	if (argc != 2) {
		printf("%s", USAGE);
		exit(1);
	}
	if ((fd = open("/dev/ccd0", O_WRONLY)) < 0) {
		printf("Couldn't open ccd0, errno: %d\n", errno);
		exit(1);
	}
	switch ((int)argv[1][0]) {
	case 'a':
		if (ioctl(fd, CCD_IOCSABORT, 0) < 0) {
			printf("Couldn't abort ccd0, errno: %d\n", errno);
			exit(1);
		}
		break;
	case 'c':
		if (ioctl(fd, CCD_IOCSCANCEL, 0) < 0) {
			printf("Couldn't cancel ccd0, errno: %d\n", errno);
			exit(1);
		}
		break;
	case 'h':
		if (ioctl(fd, CCD_IOCSHANGUP, 0) < 0) {
			printf("Couldn't hangup ccd0, errno: %d\n", errno);
			exit(1);
		}
		break;
	case 'r':
		if (ioctl(fd, CCD_IOCSRESUME, 0) < 0) {
			printf("Couldn't resume ccd0, errno: %d\n", errno);
			exit(1);
		}
		break;
        case 't':
                if (ioctl(fd, CCD_IOCSTEST, 0) < 0) {
                        printf("Couldn't test ccd0, errno: %d\n", errno);
                        exit(1);
                }
                break;

	default:
		printf("%s", USAGE);
		exit(1);
		break;
	}
	exit(0);
}
